# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TerraformVersion(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'version': 'str',
        'description': 'str',
        'url': 'str',
        'authentication_type': 'str',
        'username': 'str',
        'password': 'str',
        'sha256_checksum': 'str',
        'enabled': 'bool',
        'created_at': 'datetime',
        'created_by': 'str',
        'updated_at': 'datetime',
        'updated_by': 'str',
        'org_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'version': 'version',
        'description': 'description',
        'url': 'url',
        'authentication_type': 'authenticationType',
        'username': 'username',
        'password': 'password',
        'sha256_checksum': 'sha256Checksum',
        'enabled': 'enabled',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'updated_at': 'updatedAt',
        'updated_by': 'updatedBy',
        'org_id': 'orgId'
    }

    def __init__(self, id=None, version=None, description=None, url=None, authentication_type=None, username=None, password=None, sha256_checksum=None, enabled=None, created_at=None, created_by=None, updated_at=None, updated_by=None, org_id=None):  # noqa: E501
        """TerraformVersion - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._version = None
        self._description = None
        self._url = None
        self._authentication_type = None
        self._username = None
        self._password = None
        self._sha256_checksum = None
        self._enabled = None
        self._created_at = None
        self._created_by = None
        self._updated_at = None
        self._updated_by = None
        self._org_id = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if version is not None:
            self.version = version
        if description is not None:
            self.description = description
        if url is not None:
            self.url = url
        if authentication_type is not None:
            self.authentication_type = authentication_type
        if username is not None:
            self.username = username
        if password is not None:
            self.password = password
        if sha256_checksum is not None:
            self.sha256_checksum = sha256_checksum
        if enabled is not None:
            self.enabled = enabled
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if updated_at is not None:
            self.updated_at = updated_at
        if updated_by is not None:
            self.updated_by = updated_by
        if org_id is not None:
            self.org_id = org_id

    @property
    def id(self):
        """Gets the id of this TerraformVersion.  # noqa: E501

        Version ID  # noqa: E501

        :return: The id of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TerraformVersion.

        Version ID  # noqa: E501

        :param id: The id of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def version(self):
        """Gets the version of this TerraformVersion.  # noqa: E501

        The numeric version of terraform release  # noqa: E501

        :return: The version of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this TerraformVersion.

        The numeric version of terraform release  # noqa: E501

        :param version: The version of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def description(self):
        """Gets the description of this TerraformVersion.  # noqa: E501

        Version description  # noqa: E501

        :return: The description of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TerraformVersion.

        Version description  # noqa: E501

        :param description: The description of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def url(self):
        """Gets the url of this TerraformVersion.  # noqa: E501

        Download url  # noqa: E501

        :return: The url of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this TerraformVersion.

        Download url  # noqa: E501

        :param url: The url of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def authentication_type(self):
        """Gets the authentication_type of this TerraformVersion.  # noqa: E501

        The type of authentication for the download url  # noqa: E501

        :return: The authentication_type of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._authentication_type

    @authentication_type.setter
    def authentication_type(self, authentication_type):
        """Sets the authentication_type of this TerraformVersion.

        The type of authentication for the download url  # noqa: E501

        :param authentication_type: The authentication_type of this TerraformVersion.  # noqa: E501
        :type: str
        """
        allowed_values = ["NONE", "BASIC"]  # noqa: E501
        if authentication_type not in allowed_values:
            raise ValueError(
                "Invalid value for `authentication_type` ({0}), must be one of {1}"  # noqa: E501
                .format(authentication_type, allowed_values)
            )

        self._authentication_type = authentication_type

    @property
    def username(self):
        """Gets the username of this TerraformVersion.  # noqa: E501

        The user name for basic authentication  # noqa: E501

        :return: The username of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this TerraformVersion.

        The user name for basic authentication  # noqa: E501

        :param username: The username of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def password(self):
        """Gets the password of this TerraformVersion.  # noqa: E501

        The password for basic authentication  # noqa: E501

        :return: The password of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this TerraformVersion.

        The password for basic authentication  # noqa: E501

        :param password: The password of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def sha256_checksum(self):
        """Gets the sha256_checksum of this TerraformVersion.  # noqa: E501

        The sha256 checksum of the terraform binary  # noqa: E501

        :return: The sha256_checksum of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._sha256_checksum

    @sha256_checksum.setter
    def sha256_checksum(self, sha256_checksum):
        """Sets the sha256_checksum of this TerraformVersion.

        The sha256 checksum of the terraform binary  # noqa: E501

        :param sha256_checksum: The sha256_checksum of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._sha256_checksum = sha256_checksum

    @property
    def enabled(self):
        """Gets the enabled of this TerraformVersion.  # noqa: E501

        Version status  # noqa: E501

        :return: The enabled of this TerraformVersion.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this TerraformVersion.

        Version status  # noqa: E501

        :param enabled: The enabled of this TerraformVersion.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def created_at(self):
        """Gets the created_at of this TerraformVersion.  # noqa: E501

        Created time  # noqa: E501

        :return: The created_at of this TerraformVersion.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this TerraformVersion.

        Created time  # noqa: E501

        :param created_at: The created_at of this TerraformVersion.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this TerraformVersion.  # noqa: E501

        Created by  # noqa: E501

        :return: The created_by of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this TerraformVersion.

        Created by  # noqa: E501

        :param created_by: The created_by of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def updated_at(self):
        """Gets the updated_at of this TerraformVersion.  # noqa: E501

        Updated time  # noqa: E501

        :return: The updated_at of this TerraformVersion.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this TerraformVersion.

        Updated time  # noqa: E501

        :param updated_at: The updated_at of this TerraformVersion.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def updated_by(self):
        """Gets the updated_by of this TerraformVersion.  # noqa: E501

        Updated by  # noqa: E501

        :return: The updated_by of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this TerraformVersion.

        Updated by  # noqa: E501

        :param updated_by: The updated_by of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def org_id(self):
        """Gets the org_id of this TerraformVersion.  # noqa: E501

        Org ID  # noqa: E501

        :return: The org_id of this TerraformVersion.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this TerraformVersion.

        Org ID  # noqa: E501

        :param org_id: The org_id of this TerraformVersion.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TerraformVersion, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TerraformVersion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
